diff -uNr mythtv-0.21/i18n/mythfrontend_sv.ts mythtv/i18n/mythfrontend_sv.ts
--- mythtv-0.21/i18n/mythfrontend_sv.ts	2008-03-04 04:48:46.000000000 +0100
+++ mythtv/i18n/mythfrontend_sv.ts	2008-03-31 01:23:38.000000000 +0200
@@ -10434,91 +10525,91 @@
     <name>SIScan</name>
     <message>
         <source>Updated Channel %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Uppdaterad Kanal %1</translation>
     </message>
     <message>
         <source>Added Channel %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Tillagd Kanal %1</translation>
     </message>
     <message>
         <source>Failed to add channel %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Misslyckades att lägga till kanal %1</translation>
     </message>
     <message>
         <source>Network %1 Processing</source>
-        <translation type="unfinished"></translation>
+        <translation>Nätverk %1 Körning</translation>
     </message>
     <message>
         <source>Finished processing Transport List</source>
-        <translation type="unfinished"></translation>
+        <translation>Avslutade behandling av transportlista</translation>
     </message>
     <message>
         <source>Updating Services</source>
-        <translation type="unfinished"></translation>
+        <translation>Uppdaterar Tjänster</translation>
     </message>
     <message>
         <source>Finished processing Services</source>
-        <translation type="unfinished"></translation>
+        <translation>Avslutade behandling av tjänster</translation>
     </message>
     <message>
         <source>Frequency %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Frekvens %1</translation>
     </message>
     <message>
         <source>as</source>
-        <translation type="unfinished"></translation>
+        <translation>som</translation>
     </message>
     <message>
         <source>Skipping %1, not in imported channel map</source>
-        <translation type="unfinished"></translation>
+        <translation>skippar %1, inte i importerad kanalkarta</translation>
     </message>
     <message>
         <source>%1%2%3 on %4 (%5)</source>
-        <translation type="unfinished"></translation>
+        <translation>%1%2%3 på %4 (%5)</translation>
     </message>
     <message>
         <source>Adding %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Lägger till %1</translation>
     </message>
     <message>
         <source>Updating %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Uppdaterar %1</translation>
     </message>
     <message>
         <source>Skipping %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Skippar %1</translation>
     </message>
     <message>
         <source>on %1</source>
-        <translation type="unfinished"></translation>
+        <translation>på %1</translation>
     </message>
     <message>
         <source>Data Only Channel (off-air?)</source>
-        <translation type="unfinished"></translation>
+        <translation>Endast Datakanal (inte i sändning?)</translation>
     </message>
     <message>
         <source>Empty Channel (off-air?)</source>
-        <translation type="unfinished"></translation>
+        <translation>Tom Kanal (inte i sändning?)</translation>
     </message>
     <message>
         <source>Audio Only Channel</source>
-        <translation type="unfinished"></translation>
+        <translation>Endast Ljudkanal</translation>
     </message>
     <message>
         <source>Encrypted Channel</source>
-        <translation type="unfinished"></translation>
+        <translation>Krypterad Kanal</translation>
     </message>
     <message>
         <source>%1 %2-%3 as %4 on %5 (%6)</source>
-        <translation type="unfinished"></translation>
+        <translation></translation>
     </message>
     <message>
         <source>Found channel, but it doesn&apos;t match existing tsid. You may wish to delete existing channels and do a full scan.</source>
-        <translation type="unfinished"></translation>
+        <translation>Hittade kanal, men den matchar inte existerande tsid. Du kanske vill radera existerande kanaler och göra en omsökning av kanaler.</translation>
     </message>
     <message>
         <source>Skipping %1 - already in DB, and we don&apos;t have better data.</source>
-        <translation type="unfinished"></translation>
+        <translation>Skippar %1 - redan i databas, och vi har ingen bättre data.</translation>
     </message>
 </context>
 <context>
@@ -10729,94 +10820,95 @@
     </message>
     <message>
         <source>marked as HDTV</source>
-        <translation type="unfinished"></translation>
+        <translation>markera som HDTV</translation>
     </message>
     <message>
         <source>from source</source>
-        <translation type="unfinished"></translation>
+        <translation>från källa</translation>
     </message>
     <message>
         <source>on input</source>
-        <translation type="unfinished"></translation>
+        <translation>på ingång</translation>
     </message>
     <message>
         <source>%1 of these are Deleted and consume %2</source>
-        <translation type="unfinished"></translation>
+        <translation>%1 av dessa är raderade och använder %2</translation>
     </message>
 </context>
 <context>
     <name>StorageGroupEditor</name>
     <message>
         <source>&apos;%1&apos; Storage Group Directories</source>
-        <translation type="unfinished"></translation>
+        <translation>&apos;%1&apos; Kataloger för lagringsgrupper</translation>
     </message>
     <message>
         <source>Local &apos;%1&apos; Storage Group Directories</source>
-        <translation type="unfinished"></translation>
+        <translation>Lokala &apos;%1&apos; kataloger för lagringsgrupp</translation>
     </message>
     <message>
         <source>Add Storage Group Directory</source>
-        <translation type="unfinished"></translation>
+        <translation>Lägg till katalog för lagringsgrupp</translation>
     </message>
     <message>
         <source>Enter directory name or press SELECT to enter text via the On Screen Keyboard</source>
-        <translation type="unfinished"></translation>
+        <translation>Ange katalognamn eller tryck SELECT för att skriva med det virtuella tangentbordet</translation>
     </message>
     <message>
         <source>Edit Storage Group Directory</source>
-        <translation type="unfinished"></translation>
+        <translation>Redigera katalog för lagringsgrupp </translation>
     </message>
     <message>
         <source>Remove &apos;%1&apos;
 Directory From Storage Group?</source>
-        <translation type="unfinished"></translation>
+        <translation>Radera &apos;%1&apos;
+Katalog Från Lagringsgrupp?</translation>
     </message>
     <message>
         <source>Yes, remove directory</source>
-        <translation type="unfinished"></translation>
+        <translation>Ja, radera katalog</translation>
     </message>
     <message>
         <source>No, Don&apos;t remove directory</source>
-        <translation type="unfinished"></translation>
+        <translation>Nej, radera inte katalog</translation>
     </message>
     <message>
         <source>(Add New Directory)</source>
-        <translation type="unfinished"></translation>
+        <translation>(Lägg Till Ny Katalog)</translation>
     </message>
 </context>
 <context>
     <name>StorageGroupListEditor</name>
     <message>
         <source>Storage Groups (directories for new recordings)</source>
-        <translation type="unfinished"></translation>
+        <translation>Lagringsgrupp (kataloger för nya inspelningar)</translation>
     </message>
     <message>
         <source>Local Storage Groups (directories for new recordings)</source>
-        <translation type="unfinished"></translation>
+        <translation>Lokala lagringsgrupper (kataloger för nya inspelningar)</translation>
     </message>
     <message>
         <source>Create New Storage Group</source>
-        <translation type="unfinished"></translation>
+        <translation>Skapa Nya Lagringsgrupper</translation>
     </message>
     <message>
         <source>Enter group name or press SELECT to enter text via the On Screen Keyboard</source>
-        <translation type="unfinished">Skriv in gruppnamn eller tryck SELECT för att skriva in text med det virtuella tangentbordet</translation>
+        <translation>Skriv in gruppnamn eller tryck SELECT för att skriva in text med det virtuella tangentbordet</translation>
     </message>
     <message>
         <source>Delete &apos;%1&apos; Storage Group?</source>
-        <translation type="unfinished"></translation>
+        <translation>Radera &apos;%1&apos; lagringsgrupp?</translation>
     </message>
     <message>
         <source>Yes, delete group</source>
-        <translation type="unfinished">Ja, ta bort grupp</translation>
+        <translation>Ja, radera grupp</translation>
     </message>
     <message>
         <source>No, Don&apos;t delete group</source>
-        <translation type="unfinished">Nej, ta inte bort grupp</translation>
+        <translation>Nej, radera inte grupp</translation>
     </message>
     <message>
         <source>(Create %1 group)</source>
-        <translation type="unfinished"></translation>
+        <translation>(skapa %1 grupp)</translation>
     </message>
 </context>
 <context>
@@ -11510,73 +11602,81 @@
     </message>
     <message>
         <source>Exit</source>
-        <translation type="unfinished">Avsluta</translation>
+        <translation>Avsluta</translation>
     </message>
     <message>
         <source>MythTV wants to record &quot;%1&quot; on %2 in %d seconds. Do you want to:</source>
-        <translation type="unfinished"></translation>
+        <translation>MythTV kommer att spela in  &quot;%1&quot; på %2 om %d seunder. Vill du:</translation>
     </message>
     <message>
         <source>Let them record and go back to the Main Menu</source>
-        <translation type="unfinished"></translation>
+        <translation>Låt dom spelas in och gå tillbaka till huvudmenyn</translation>
     </message>
     <message>
         <source>Record it later, I want to watch TV</source>
-        <translation type="unfinished"></translation>
+        <translation>Spela in senare, jag vill se på TV</translation>
     </message>
     <message>
         <source>Record them later, I want to watch TV</source>
-        <translation type="unfinished"></translation>
+        <translation>Spela in dem senare, jag vill se på TV</translation>
     </message>
     <message>
         <source>Don&apos;t let them record, I want to watch TV</source>
-        <translation type="unfinished"></translation>
+        <translation>Låt dom inte spelas in, jag vill se på TV</translation>
     </message>
     <message>
         <source>You should have gotten a channel lock by now. You can continue to wait for a signal, or you can change the channels with %1 or %2, change video source (%3), inputs (%4), etc.</source>
-        <translation type="unfinished"></translation>
+        <translation>Du borde ha fått kanallåsning vi det här laget. Du kan fortsätta att vänta på signal, byta kanal med %1 or %2, byta videokälla (%3), ingångar (%4), etc.</translation>
     </message>
     <message>
         <source>Yes</source>
-        <translation type="unfinished">Ja</translation>
+        <translation>Ja</translation>
     </message>
     <message>
         <source>Adjust Fill</source>
-        <translation type="unfinished"></translation>
+        <translation>Justera Fyllningsgrad</translation>
     </message>
     <message>
         <source>Switch Input</source>
-        <translation type="unfinished"></translation>
+        <translation>Växla Ingång</translation>
     </message>
     <message>
         <source>C</source>
         <comment>Card</comment>
-        <translation type="unfinished">K</translation>
+        <translation>K</translation>
     </message>
     <message>
         <source>I</source>
         <comment>Input</comment>
-        <translation type="unfinished"></translation>
+        <translation>I</translation>
     </message>
     <message>
         <source>Switch Source</source>
-        <translation type="unfinished"></translation>
+        <translation>Växla Källa</translation>
     </message>
     <message>
         <source>Upcoming Recordings</source>
-        <translation type="unfinished"></translation>
+        <translation>Uppkommande Inspelningar</translation>
     </message>
     <message>
         <source>Error</source>
-        <translation type="unfinished"></translation>
+        <translation>Fel</translation>
     </message>
     <message>
         <source>You are exiting %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Du håller på att gå ut ur %1</translation>
     </message>
     <message>
         <source>Exit %1</source>
-        <translation type="unfinished"></translation>
+        <translation>Avsluta %1</translation>
+    </message>
+    <message>
+        <source>MythTV is using all inputs for Live TV?</source>
+        <translation>Använder MythTV alla ingångar för TV mottagning?</translation>
+    </message>
+    <message>
+        <source>MythTV has no capture cards defined. Please run the mythtv-setup program.</source>
+        <translation>MythTV har inga mottagare definierade. Var god och kör mythtv-setup programmet.</translation>
     </message>
 </context>
 <context>
@@ -11813,26 +11913,26 @@
     </message>
     <message>
         <source>Multiplex Editor</source>
-        <translation type="unfinished"></translation>
+        <translation>Multiplex Redigerare</translation>
     </message>
 </context>
 <context>
     <name>UIListBtnType</name>
     <message>
         <source>Search</source>
-        <translation type="unfinished">Sök</translation>
+        <translation>Sök</translation>
     </message>
     <message>
         <source>Starts with text</source>
-        <translation type="unfinished">Börjar med text</translation>
+        <translation>Börjar med text</translation>
     </message>
     <message>
         <source>Contains text</source>
-        <translation type="unfinished">Innehåller text</translation>
+        <translation>Innehåller text</translation>
     </message>
     <message>
         <source>Cancel</source>
-        <translation type="unfinished">Avbryt</translation>
+        <translation>Avbryt</translation>
     </message>
 </context>
 <context>
@@ -11954,11 +12054,11 @@
     </message>
     <message>
         <source>Conflict Today</source>
-        <translation type="unfinished"></translation>
+        <translation>Konflikt Idag</translation>
     </message>
     <message>
         <source>Conflict </source>
-        <translation type="unfinished"></translation>
+        <translation>Konflikt </translation>
     </message>
 </context>
 <context>
@@ -12075,11 +12175,11 @@
     </message>
     <message>
         <source>to</source>
-        <translation type="unfinished"></translation>
+        <translation>till </translation>
     </message>
     <message>
         <source>MythTV has running or pending jobs.</source>
-        <translation type="unfinished"></translation>
+        <translation>MythTV har pågående eller avvaktande jobb.</translation>
     </message>
 </context>
 <context>
diff -uNr mythtv-0.21/libs/libavcodec/ac3dec.c mythtv/libs/libavcodec/ac3dec.c
--- mythtv-0.21/libs/libavcodec/ac3dec.c	2008-02-10 21:56:11.000000000 +0100
+++ mythtv/libs/libavcodec/ac3dec.c	2008-04-21 18:28:52.000000000 +0200
@@ -35,6 +35,7 @@
 #include "avcodec.h"
 #include "ac3_parser.h"
 #include "bitstream.h"
+#include "crc.h"
 #include "dsputil.h"
 #include "random.h"
 
@@ -1121,6 +1122,16 @@
         return -1;
     }
 
+    /* check for crc mismatch */
+    if(avctx->error_resilience >= FF_ER_CAREFUL) {
+        if(av_crc(av_crc8005, 0, &buf[2], ctx->frame_size-2)) {
+            av_log(avctx, AV_LOG_ERROR, "frame CRC mismatch\n");
+            *data_size = 0;
+            return ctx->frame_size;
+        }
+        /* TODO: error concealment */
+    }
+
     avctx->sample_rate = ctx->sampling_rate;
     avctx->bit_rate = ctx->bit_rate;
 
diff -uNr mythtv-0.21/libs/libavcodec/libavcodec.pro mythtv/libs/libavcodec/libavcodec.pro
--- mythtv-0.21/libs/libavcodec/libavcodec.pro	2008-02-06 04:02:47.000000000 +0100
+++ mythtv/libs/libavcodec/libavcodec.pro	2008-06-04 06:05:51.000000000 +0200
@@ -27,8 +27,6 @@
 	QMAKE_CFLAGS_SHLIB =
 }
 
-mingw:target.path = $${PREFIX}/bin
-
 !profile:QMAKE_CFLAGS_DEBUG += -O
 
 QMAKE_CLEAN += $(TARGET) $(TARGETA) $(TARGETD) $(TARGET0) $(TARGET1) $(TARGET2)
@@ -410,7 +408,7 @@
 }
 
 contains( HAVE_ARMV5TE, yes ) {
-    SOURCES += armv4l/simple_idct_armv5te.S armv4l/mpegvideo_armv5te.S
+    SOURCES += armv4l/simple_idct_armv5te.S armv4l/mpegvideo_armv5te.c
 }
 
 contains( HAVE_ARMV6, yes )      { SOURCES += armv4l/simple_idct_armv6.S }
@@ -467,3 +465,4 @@
     SOURCES += bfin/vp3_idct_bfin.S
 }
 
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libavformat/libavformat.pro mythtv/libs/libavformat/libavformat.pro
--- mythtv-0.21/libs/libavformat/libavformat.pro	2008-02-06 04:02:47.000000000 +0100
+++ mythtv/libs/libavformat/libavformat.pro	2008-06-04 06:05:51.000000000 +0200
@@ -13,8 +13,6 @@
 
 LIBS += $$LOCAL_LIBDIR_X11 $$EXTRALIBS
 
-mingw:  target.path = $${PREFIX}/bin
-
 QMAKE_CLEAN += $(TARGET) $(TARGETA) $(TARGETD) $(TARGET0) $(TARGET1) $(TARGET2)
 
 # Input
@@ -198,3 +196,5 @@
 }
 
 mingw:SOURCES -= audio.c
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libavformat/utils.c mythtv/libs/libavformat/utils.c
--- mythtv-0.21/libs/libavformat/utils.c	2008-02-21 23:29:22.000000000 +0100
+++ mythtv/libs/libavformat/utils.c	2008-03-26 16:51:18.000000000 +0100
@@ -580,6 +580,10 @@
 
     *pnum = 0;
     *pden = 0;
+
+    if (!st || !st->codec)
+        return;
+    
     switch(st->codec->codec_type) {
     case CODEC_TYPE_VIDEO:
         if(st->time_base.num*1000LL > st->time_base.den){
@@ -792,7 +796,7 @@
     for(;;) {
         /* select current input stream component */
         st = s->cur_st;
-        if (st) {
+        if (st && st->codec) {
             if (!st->need_parsing || !st->parser) {
                 /* no parsing needed: we just output the packet as is */
                 /* raw data support */
@@ -867,7 +871,7 @@
                 s->cur_pkt.pos = startpos;
 
             st = s->streams[s->cur_pkt.stream_index];
-            if(st->codec->debug & FF_DEBUG_PTS)
+            if(st && st->codec && st->codec->debug & FF_DEBUG_PTS)
                 av_log(s, AV_LOG_DEBUG, "av_read_packet stream=%d, pts=%"PRId64", dts=%"PRId64", size=%d\n",
                     s->cur_pkt.stream_index,
                     s->cur_pkt.pts,
@@ -877,7 +881,7 @@
             s->cur_st = st;
             s->cur_ptr = s->cur_pkt.data;
             s->cur_len = s->cur_pkt.size;
-            if (st->need_parsing && !st->parser) {
+            if (st && st->codec && st->need_parsing && !st->parser) {
                 st->parser = av_parser_init(st->codec->codec_id);
                 if (!st->parser) {
                     /* no parser available : just output the raw packets */
@@ -892,7 +896,7 @@
             }
         }
     }
-    if(st->codec->debug & FF_DEBUG_PTS)
+    if(st->codec && st->codec->debug & FF_DEBUG_PTS)
         av_log(s, AV_LOG_DEBUG, "av_read_frame_internal stream=%d, pts=%"PRId64", dts=%"PRId64", size=%d\n",
             pkt->stream_index,
             pkt->pts,
diff -uNr mythtv-0.21/libs/libavutil/libavutil.pro mythtv/libs/libavutil/libavutil.pro
--- mythtv-0.21/libs/libavutil/libavutil.pro	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libavutil/libavutil.pro	2008-06-04 06:05:51.000000000 +0200
@@ -53,4 +53,4 @@
     QMAKE_LFLAGS_SHLIB += -seg1addr 0xC2000000
 }
 
-mingw:  target.path = $${PREFIX}/bin
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmyth/compat.h mythtv/libs/libmyth/compat.h
--- mythtv-0.21/libs/libmyth/compat.h	2008-02-18 08:35:01.000000000 +0100
+++ mythtv/libs/libmyth/compat.h	2008-06-11 13:46:52.000000000 +0200
@@ -278,4 +278,9 @@
     #define lseek64(f,o,w) lseek(f,o,w)
 #endif
 
+#ifdef __FreeBSD__
+    typedef off_t off64_t;
+#endif
+
+
 #endif // __COMPAT_H__
diff -uNr mythtv-0.21/libs/libmyth/libmyth.pro mythtv/libs/libmyth/libmyth.pro
--- mythtv-0.21/libs/libmyth/libmyth.pro	2008-03-04 18:08:41.000000000 +0100
+++ mythtv/libs/libmyth/libmyth.pro	2008-06-30 08:40:35.000000000 +0200
@@ -83,6 +83,10 @@
 inc2.files = $${inc.files}
 
 
+DEFINES += RUNPREFIX=\"$${RUNPREFIX}\"
+DEFINES += LIBDIRNAME=\"$${LIBDIRNAME}\"
+
+
 using_oss {
     DEFINES += USING_OSS
     SOURCES += audiooutputoss.cpp
@@ -107,9 +111,6 @@
 
     LIBS += -lpthread
 
-    # For easier debugging:
-    target.path = $${PREFIX}/bin
-
     LIBS -= -lmythui-$$LIBVERSION  -lmythupnp-$$LIBVERSION 
     LIBS += -L. -lmythui-bootstrap -lmythupnp-bootstrap
     POST_TARGETDEPS += libmythui-bootstrap.a libmythupnp-bootstrap.a
@@ -241,3 +242,5 @@
 contains( CONFIG_LIBFFTW3, yes ) {
     LIBS += -lfftw3f
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmyth/mythcontext.cpp mythtv/libs/libmyth/mythcontext.cpp
--- mythtv-0.21/libs/libmyth/mythcontext.cpp	2008-03-07 01:50:20.000000000 +0100
+++ mythtv/libs/libmyth/mythcontext.cpp	2008-06-30 08:40:35.000000000 +0200
@@ -224,9 +224,9 @@
     Settings *m_settings;          ///< connection stuff, theme, button style
     Settings *m_qtThemeSettings;   ///< everything else theme-related
 
-    QString   m_installprefix;     ///< Compile-time PREFIX, or generated
+    QString   m_installprefix;     ///< Compile-time RUNPREFIX, or generated
                                    ///< from enviroment ($MYTHTVDIR or $cwd)
-    QString   m_installlibdir;     ///< Compile-time LIBDIR, or generated
+    QString   m_libname;           ///< Compile-time LIBDIRNAME
 
     bool      m_gui;               ///< Should this context use GUI elements?
     bool      m_backend;           ///< Is this host any sort of backend?
@@ -314,7 +314,7 @@
 MythContextPrivate::MythContextPrivate(MythContext *lparent)
     : parent(lparent),
       m_settings(new Settings()), m_qtThemeSettings(new Settings()),
-      m_installprefix(PREFIX), m_installlibdir(LIBDIR),
+      m_installprefix(RUNPREFIX), m_libname(LIBDIRNAME),
       m_gui(false), m_backend(false), m_themeloaded(false),
       m_menuthemepathname(QString::null), m_themepathname(QString::null),
       m_backgroundimage(NULL),
@@ -356,21 +356,15 @@
         // If the PREFIX is relative, evaluate it relative to our
         // executable directory. This can be fragile on Unix, so
         // use relative PREFIX values with care.
+
+        VERBOSE(VB_IMPORTANT,
+                "Relative PREFIX! (" + m_installprefix +
+                ")\n\t\tappDir=" + prefixDir.canonicalPath());
         prefixDir.cd(m_installprefix);
         m_installprefix = prefixDir.canonicalPath();
     }
-    else if (prefixDir.path().contains(".app/Contents/MacOS"))
-    {
-        prefixDir.cd("../Resources");
-        if (QDir(prefixDir.canonicalPath() + "/bin").exists() ||
-            QDir(prefixDir.canonicalPath() + "/share").exists())
-            m_installprefix = prefixDir.canonicalPath();
-        if (QDir(prefixDir.canonicalPath() + "/lib").exists())
-            m_installlibdir = prefixDir.canonicalPath() + "/lib";
-    }
 
-    VERBOSE(VB_IMPORTANT, QString("Using runtime prefix = %1, libdir = %2")
-                          .arg(m_installprefix).arg(m_installlibdir));
+    VERBOSE(VB_IMPORTANT, "Using runtime prefix = " + m_installprefix);
 }
 
 MythContextPrivate::~MythContextPrivate()
@@ -463,19 +457,33 @@
     }
 
     QDesktopWidget * desktop = QApplication::desktop();
+    bool             hasXinerama = GetNumberOfXineramaScreens() > 1;
+    int              numScreens  = desktop->numScreens();
+    int              screen;
 
-    VERBOSE(VB_IMPORTANT,
-            QString("Total desktop dim: %1x%2, with %3 screen[s].")
-            .arg(desktop->width()).arg(desktop->height())
-            .arg(desktop->numScreens()));
+    if (hasXinerama)
+        VERBOSE(VB_GENERAL,
+                QString("Total desktop dim: %1x%2, over %3 screen[s].")
+                .arg(desktop->width()).arg(desktop->height()).arg(numScreens));
+    if (numScreens > 1)
+        for (screen = 0; screen < numScreens; ++screen)
+        {
+            QRect dim = desktop->screenGeometry(screen);
+            VERBOSE(VB_GENERAL,
+                    QString("Screen %1 dim: %2x%3.")
+                    .arg(screen).arg(dim.width()).arg(dim.height()));
+        }
+
+    screen = desktop->primaryScreen();
+    VERBOSE(VB_GENERAL, QString("Primary screen %1.").arg(screen));
 
-    int screen = parent->GetNumSetting("XineramaScreen",
-                                       desktop->primaryScreen());
+    if (hasXinerama)
+        screen = parent->GetNumSetting("XineramaScreen", screen);
 
     if (screen == -1)       // Special case - span all screens
     {
-        VERBOSE(VB_GENERAL, QString("Using all screens (currently %1)")
-                            .arg(desktop->numScreens()));
+        VERBOSE(VB_GENERAL, QString("Using all %1 screens.")
+                                     .arg(numScreens));
         m_xbase  = 0;
         m_ybase  = 0;
         m_width  = desktop->width();
@@ -483,19 +491,23 @@
 
         VERBOSE(VB_GENERAL, QString("Total width = %1, height = %2")
                             .arg(m_width).arg(m_height));
+        return;
     }
-    else                    // User specified a single screen
+
+    if (hasXinerama)        // User specified a single screen
     {
-        if (screen < 0 || screen >= desktop->numScreens())
+        if (screen < 0 || screen >= numScreens)
         {
             VERBOSE(VB_IMPORTANT, QString(
                         "Xinerama screen %1 was specified,"
                         " but only %2 available, so using screen 0.")
-                    .arg(screen).arg(desktop->numScreens()));
+                    .arg(screen).arg(numScreens));
             screen = 0;
         }
+    }
 
 
+    {
         QRect bounds;
 
         bool inWindow = parent->GetNumSetting("RunFrontendInWindow", 0);
@@ -528,7 +540,9 @@
     if (UPnPclient)
     {
         m_UPnP = UPnPclient;
+#ifndef _WIN32
         m_XML  = (XmlConfiguration *)UPnp::g_pConfig;
+#endif
     }
 
     // Creates screen saver control if we will have a GUI
@@ -1913,7 +1927,7 @@
 
 QString MythContext::GetLibraryDir(void) 
 { 
-    return d->m_installlibdir + "/mythtv/"; 
+    return d->m_installprefix + "/" + d->m_libname + "/mythtv/"; 
 }
 
 QString MythContext::GetThemesParentDir(void) 
@@ -2461,11 +2475,17 @@
     QDir dir(testdir);
     if (dir.exists())
         return testdir;
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
+
 
     testdir = GetThemesParentDir() + themename;
     dir.setPath(testdir);
     if (dir.exists())
         return testdir;
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
+
 
     testdir = GetThemesParentDir() + "G.A.N.T";
     dir.setPath(testdir);
@@ -2476,6 +2496,8 @@
         SaveSetting("Theme", "G.A.N.T");
         return testdir;
     }
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
 
     VERBOSE(VB_IMPORTANT, QString("Could not find theme: %1").arg(themename));
     return "";
@@ -2716,8 +2738,9 @@
     }
 
     if (!found)
-        value = d->m_settings->GetSetting(key, defaultval); 
+        return d->m_settings->GetSetting(key, defaultval); 
 
+    // Store the value (only if we have actually found it in the database)
     if (!value.isNull() && d && d->useSettingsCache)
     {
         d->settingsCacheLock.lock();
@@ -3483,7 +3506,7 @@
 
 
     // No current DBSchemaVer? Empty database, so upgrade to create tables
-    if (dbver.isEmpty())
+    if (dbver.isEmpty() || dbver == "0")
     {
         VERBOSE(VB_GENERAL, "No current database version. Auto upgrading");
         return MYTH_SCHEMA_UPGRADE;
diff -uNr mythtv-0.21/libs/libmyth/storagegroup.cpp mythtv/libs/libmyth/storagegroup.cpp
--- mythtv-0.21/libs/libmyth/storagegroup.cpp	2008-02-15 01:30:26.000000000 +0100
+++ mythtv/libs/libmyth/storagegroup.cpp	2008-07-06 08:27:55.000000000 +0200
@@ -394,6 +394,9 @@
         if (result == SGPopup_CANCEL)
             return;
 
+        if (name == "")
+            return;
+
         if (name.right(1) != "/")
             name.append("/");
 
diff -uNr mythtv-0.21/libs/libmyth/util.cpp mythtv/libs/libmyth/util.cpp
--- mythtv-0.21/libs/libmyth/util.cpp	2008-02-24 16:19:20.000000000 +0100
+++ mythtv/libs/libmyth/util.cpp	2008-06-11 13:46:52.000000000 +0200
@@ -24,6 +24,9 @@
 #   include <sys/sysinfo.h>
 # else
 #   include <sys/param.h>
+#   ifdef __FreeBSD__ 
+#     include <sys/mount.h> 
+#   endif
 #   ifdef CONFIG_CYGWIN
 #     include <sys/statfs.h>
 #   else // if !CONFIG_CYGWIN
@@ -293,10 +296,11 @@
                     return GENERIC_EXIT_NOT_OK;
                 }
 
+                qApp->processEvents();
+
                 if (res > 0)
                     return WEXITSTATUS(status);
 
-                qApp->processEvents();
                 usleep(100000);
             }
         }
diff -uNr mythtv-0.21/libs/libmythdvdnav/libmythdvdnav.pro mythtv/libs/libmythdvdnav/libmythdvdnav.pro
--- mythtv-0.21/libs/libmythdvdnav/libmythdvdnav.pro	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythdvdnav/libmythdvdnav.pro	2008-06-04 06:05:51.000000000 +0200
@@ -38,3 +38,5 @@
 }
 
 mingw:DEFINES += STDC_HEADERS
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythdvdnav/nav_read.c mythtv/libs/libmythdvdnav/nav_read.c
--- mythtv-0.21/libs/libmythdvdnav/nav_read.c	2006-02-15 08:18:03.000000000 +0100
+++ mythtv/libs/libmythdvdnav/nav_read.c	2008-06-21 17:07:33.000000000 +0200
@@ -353,6 +353,8 @@
   /* Asserts */
 
   /* dsi dsi gi */
+#ifdef LOG_DEBUG
   CHECK_VALUE(dsi->dsi_gi.zero1 == 0);
+#endif
 }
 
